module.exports = registerEndpoints

function registerEndpoints (octokit, routes) {
  Object.keys(routes).forEach(namespaceName => {
    octokit[namespaceName] = {}

    Object.keys(routes[namespaceName]).forEach(apiName => {
      let apiOptions = routes[namespaceName][apiName]

      const endpointDefaults = ['method', 'url', 'headers'].reduce((map, key) => {
        if (typeof apiOptions[key] !== 'undefined') {
          map[key] = apiOptions[key]
        }

        return map
      }, {})

      endpointDefaults.request = {
        validate: apiOptions.params
      }

      octokit[namespaceName][apiName] = octokit.request.defaults(endpointDefaults)
    })
  })
}
